#lang racket/base

(provide define/extend define/augment* send/values)

(require (only-in racket/class define/override super define/augment inner send/apply))
(define-syntax define/extend
  (syntax-rules ()
    [(_ («method»:id «arg»:id ...)
        #:super-call «call»:id
        «body»:expr ...)
     (define/override («method»:id «arg»:id ...)
       (define («call»:id) (super «method»:id «arg»:id ...))
       «body»:expr ...)]
    [(_ («method»:id «arg»:id ...) #:super-first «body»:expr ...)
     (define/extend («method»:id «arg»:id ...)
       #:super-call super-call (super-call)
       «body»:expr ...)]
    [(_ («method»:id «arg»:id ...) #:super-last «body»:expr ...)
     (define/extend («method»:id «arg»:id ...)
       #:super-call super-call
       «body»:expr ...
       (super-call))]))

(define-syntax define/augment*
  (syntax-rules ()
    [(_ («method»:id «arg»:id ...) #:inner-call «call»:id
        «body»:expr ...)
     (define/augment («method»:id «arg»:id ...)
       (define («call»:id) (inner (void) «method»:id «arg»:id ...))
       «body»:expr ...)]
    [(_ («method»:id «arg»:id ...) #:inner-first «body»:expr ...)
     (define/augment* («method»:id «arg»:id ...)
       #:inner-call inner-call
       (inner-call)
       «body»:expr ...)]
    [(_ («method»:id «arg»:id ...) #:inner-last «body»:expr ...)
     (define/augment* («method»:id «arg»:id ...)
       #:inner-call inner-call
       «body»:expr ...
       (inner-call))]))

(define-syntax-rule (send/values «object»:expr «method»:id «a»:expr ... «vs»:expr)
  (call-with-values (λ () «vs»:expr)
                    (λ vs (send/apply «object»:expr «method»:id «a»:expr ... vs))))

