#lang racket/base (provide ♯as-color%
                           editor<%>-mixin-interface editor<%>-mixin
                           (all-from-out racket/gui/base))

(require snack/preferences
         snack/iteration snack/syntax
         (submod snack/class implement)
         (only-in racket/gui/base color% text% the-color-database))

(define (♯as-color% a-color)
  (or (and (is-a? a-color color%) a-color)
      (and (string? a-color) (send the-color-database find-color a-color))))

(define text%-interface (class->interface text%))
;
(define editor<%>-mixin-interface (interface (text%-interface)
                                    editor:get-current-preferred-font-size
                                    get-position-values position-locations-values
                                    position&line->relative-position line&relative-position->position
                                    visual-side/false))
;
(define editor<%>-mixin
  (mixin (text%-interface) (editor<%>-mixin-interface)
    
    (inherit get-position position-locations line-start-position line-end-position get-text)
    
    (define/public (editor:get-current-preferred-font-size)
      (preferences:get 'framework:standard-style-list:font-size))
    
    (define/public (get-position-values) (get-position b₀ b₁) (values (unbox b₀) (unbox b₁)))
    ;
    (define/public (position-locations-values position eol?)
      ; #true is ‘whole-line?’ parameter, whether to use whole line for ys.
      (position-locations position b₀ b₁ #false b₂ eol? #true)
      (apply values (map unbox (list b₀ b₁ b₂))))
    ;
    (define-values (b₀ b₁ b₂) (values (box 0) (box 0) (box 0))) 
   
    #| Position to relative position, in line. User makes word-wrap decision by supplying `line`. |#
    (define/public (position&line->relative-position position line)
      (- position (line-start-position line)))
    (define/public (line&relative-position->position line relative-position)
      (+ (line-start-position line) relative-position))
    (define/public (visual-side/false line left?)
      (define-values (side-position other-side-position step adjust₀ adjust₁)
        (if left?
            (values (line-start-position line) (line-end-position   line)  1 values add1)
            (values (line-end-position   line) (line-start-position line) -1 sub1 values)))
      (for/first position (in-range side-position other-side-position step)
        #:unless (equal? " " (get-text (adjust₀ position) (adjust₁ position)))))
    
    (super-new)))